
	memset(&OverrideSample, 0, sizeof OverrideSample);
	MyIni_Load(&ini, fn);
	sec = MyIni_GetSection(&ini, "param", 0);
	
#ifdef MyIniParamRange
#undef MyIniParamRange(MIPR_VAL, MIPR_MIN, MIPR_MAX)
#endif
#define MyIniParamRange(MIPR_VAL, MIPR_MIN, MIPR_MAX) ((MIPR_VAL < MIPR_MIN) ? (MIPR_MIN) : ((MIPR_VAL > MIPR_MAX) ? (MIPR_MAX) : (MIPR_VAL)))

	OverrideSample.vibrato_delay = MyIni_GetInt32(sec, "VibratoDelay", 300);
	OverrideSample.vibrato_depth = MyIni_GetInt32(sec, "VibratoDepth", 0);
	OverrideSample.vibrato_sweep_increment = MyIni_GetInt32(sec, "VibratoSweep", 0);

	OverrideSample.vel_to_fc = MyIni_GetInt32(sec, "VelToFc", -2400);
	OverrideSample.vel_to_fc_threshold = MyIni_GetInt32(sec, "VelToFcThr", 64);
	OverrideSample.vel_to_resonance = MyIni_GetInt32(sec, "VelToRes", 0);

	OverrideSample.tremolo_delay = MyIni_GetInt32(sec, "TremoloDelay", 0);
	OverrideSample.tremolo_depth = MyIni_GetInt32(sec, "TremoloDepth", 0);
	OverrideSample.tremolo_to_fc = MyIni_GetInt32(sec, "TremoloToFc", 0);
	OverrideSample.tremolo_to_pitch = MyIni_GetInt32(sec, "TremoloToPitch", 0);

	OverrideSample.resonance = MyIni_GetInt32(sec, "Res", 0);
	OverrideSample.cutoff_freq = MyIni_GetInt32(sec, "CutoffFreq", 10000);

	OverrideSample.envelope_delay = MyIni_GetInt32(sec, "EnvDelay", 1);

	OverrideSample.modenv_delay = MyIni_GetInt32(sec, "ModEnvDelay", 1);
	OverrideSample.modenv_to_fc = MyIni_GetInt32(sec, "ModEnvToFc", 100);
	OverrideSample.modenv_to_pitch = MyIni_GetInt32(sec, "ModEnvToPitch", 0);

	otd.vibrato_cent = MyIniParamRange(MyIni_GetInt32(sec, "_VibratoCent", 55), 1, 10000);
	otd.vibrato_delay = MyIniParamRange(MyIni_GetInt32(sec, "_VibratoDelay", 200), 1, 10000);

	otd.chorus_send = MyIni_GetInt8(sec, "_SF2ChorusSend", 0);
	otd.reverb_send = MyIni_GetInt8(sec, "_SF2ReverbSend", 0);

	sec = MyIni_GetSection(&ini, "efx", 0);
	otd.gsefx_CustomODLv = MyIniParamRange(MyIni_GetFloat64(sec, "GS_OD_Level", 0.5), 0.1, 2.0);
	otd.gsefx_CustomODDrive = MyIniParamRange(MyIni_GetFloat64(sec, "GS_OD_Drive", 0.9), 0.1, 2.0);

	sec = MyIni_GetSection(&ini, "chorus", 0);
	otd.chorus_param.pre_lpf = MyIniParamRange(MyIni_GetInt8(sec, "PreLPF", 0),			0, 6);// 0;
	otd.chorus_param.level = MyIniParamRange(MyIni_GetInt8(sec, "Level", 0x40),			0, 127);//0x40;
	otd.chorus_param.feedback = MyIniParamRange(MyIni_GetInt8(sec, "Feedback", 0x08),	0, 127);//0x08;
	otd.chorus_param.delay = MyIniParamRange(MyIni_GetInt8(sec, "Delay", 0x50),			0, 127);//0x50;
	otd.chorus_param.rate = MyIniParamRange(MyIni_GetInt8(sec, "Rate", 0x03),			0, 127);//0x03;
	otd.chorus_param.depth = MyIniParamRange(MyIni_GetInt8(sec, "Depth", 0x13),			0, 127);//0x13;
	otd.chorus_param.send_reverb = MyIniParamRange(MyIni_GetInt8(sec, "SendReverb",	0), 0, 127);//0;
	otd.chorus_param.send_delay = MyIniParamRange(MyIni_GetInt8(sec, "SendDelay", 0),	0, 127);//0;

	sec = MyIni_GetSection(&ini, "main", 1);
	if (MyIni_GetUint32(sec, "ver", 100) == 100) {
		INISEC *old_sec;
		old_sec = MyIni_GetSection(&ini, "param", 0);

		MyIni_SetUint32(sec, "ver", 101);
		MyIni_SetBool(sec, "OverWriteVibrato",	MyIni_GetBool(old_sec, "_OverWriteVibrato", 1));
		MyIni_SetBool(sec, "OverWriteTremolo",	MyIni_GetBool(old_sec, "_OverWriteTremolo", 0));
		MyIni_SetBool(sec, "OverWriteVel",		0);
		MyIni_SetBool(sec, "OverWriteEnv",		0);
		MyIni_SetBool(sec, "OverWriteModEnv",	0);
		MyIni_SetBool(sec, "OverWriteCutoff",	MyIni_GetBool(old_sec, "_OverWriteCutoff", 0));

		MyIni_DeleteKey(&ini, "param", "_OverWriteVibrato");
		MyIni_DeleteKey(&ini, "param", "_OverWriteTremolo");
		MyIni_DeleteKey(&ini, "param", "_OverWriteVel");
		MyIni_DeleteKey(&ini, "param", "_OverWriteEnv");
		MyIni_DeleteKey(&ini, "param", "_OverWriteModEnv");
		MyIni_DeleteKey(&ini, "param", "_OverWriteCutoff");

		MyIni_Save(&ini, fn);
	}
	otd.overwriteMode = 0;
	otd.overwriteMode |= MyIni_GetBool(sec, "OverWriteVibrato", 1) * EOWM_ENABLE_VIBRATO;
	otd.overwriteMode |= MyIni_GetBool(sec, "OverWriteTremolo", 0) * EOWM_ENABLE_TREMOLO;
	otd.overwriteMode |= MyIni_GetBool(sec, "OverWriteCutoff", 0) * EOWM_ENABLE_CUTOFF;
	otd.overwriteMode |= MyIni_GetBool(sec, "OverWriteVel", 0) * EOWM_ENABLE_VEL;
	otd.overwriteMode |= MyIni_GetBool(sec, "OverWriteModEnv", 0) * EOWM_ENABLE_MOD;
	otd.overwriteMode |= MyIni_GetBool(sec, "OverWriteEnv", 0) * EOWM_ENABLE_ENV;

	otd.timRunMode = 0;

	sec = MyIni_GetSection(&ini, "compressor", 0);
	otd.timRunMode |= MyIni_GetBool(sec, "enable", 0) * EOWM_USE_COMPRESSOR;
	otd.compThr = MyIni_GetFloat32(sec, "threshold", 50);
	otd.compSlope = MyIni_GetFloat32(sec, "slope", 50);
	otd.compLook = MyIni_GetFloat32(sec, "lookahead", 3);
	otd.compWTime = MyIni_GetFloat32(sec, "window", 1);
	otd.compATime = MyIni_GetFloat32(sec, "attack", 0.01);
	otd.compRTime = MyIni_GetFloat32(sec, "release", 300);

	sec = MyIni_GetSection(&ini, "reverb", 0);
	scalewet = MyIni_GetFloat32(sec, "scalewet", 0.06);
	freeverb_scaleroom = MyIni_GetFloat32(sec, "scaleroom", 0.28);
	freeverb_offsetroom = MyIni_GetFloat32(sec, "offsetroom", 0.7);
	fixedgain = MyIni_GetFloat32(sec, "fixedgain", 0.025);
	combfbk = MyIni_GetFloat32(sec, "combfbk", 3.0);
	time_rt_diff = MyIni_GetFloat32(sec, "timediff", 1.0);
	
	sec = MyIni_GetSection(&ini, "delay", 0);
	otd.delay_param.delay = MyIni_GetFloat32(sec, "delay", 1.0);
	if (otd.delay_param.delay < 0.01)otd.delay_param.delay = 0.01;
	if (otd.delay_param.delay > 2.00)otd.delay_param.delay = 2.00;

	sec = MyIni_GetSection(&ini, "driver", 0);
	otd.EnableVolMidCtrl = MyIni_GetInt32(sec, "volctrl", 1);
	otd.DriverRVolume = MyIni_GetInt32(sec, "nowvol", 100);
	if (otd.DriverRVolume < 0)otd.DriverRVolume = 0;
	if (otd.DriverRVolume > 200)otd.DriverRVolume = 200;

	MyIni_SectionAllClear(&ini);

#undef MyIniParamRange
